new file mode 100755
@@ -0,0 +1,40 @@
+#!/usr/bin/env python2
+import sys
+import yaml
+import json
+import itertools
+
+def load_yaml(fname):
+ return yaml.load(open(sys.argv[1], "r").read())
+
+def conf_iter(conf):
+ def env_list(e):
+ return e if type(e) is list else [e]
+ global_env = conf["env"]["global"]
+ for c in conf["matrix"]["include"]:
+ a = { "env": global_env + env_list(c["env"]),
+ "compiler": c["compiler"]
+ }
+ yield a
+ for c in itertools.product(conf["compiler"],
+ conf["env"]["matrix"]):
+ a = { "env": global_env + env_list(c[1]),
+ "compiler": c[0]
+ }
+ yield a
+
+def main():
+ if len(sys.argv) < 2:
+ sys.stderr.write("Usage: %s <travis-file>\n" % sys.argv[0])
+ return 1
+ conf = load_yaml(sys.argv[1])
+ for config in conf_iter(conf):
+ print "("
+ print "\n".join(config["env"])
+ print "\n".join(conf["before_script"])
+ print "\n".join(conf["script"])
+ print ")"
+ return 0
+
+if __name__ == "__main__":
+ sys.exit(main())
new file mode 100755
@@ -0,0 +1,10 @@
+#!/bin/bash
+
+if ! python -c 'import yaml' &>/dev/null; then
+ echo "PyYAML not found, skip"
+ exit 0
+fi
+
+cd $(mktemp -d)
+$QEMU_SRC/tests/docker/travis.py $QEMU_SRC/.travis.yml > travis_command_list
+. travis_command_list
.travis.yml is parsed by an auxiliary python script, to generate the command list out of the matrix. TODO: respect "compiler". Signed-off-by: Fam Zheng <famz@redhat.com> --- tests/docker/travis.py | 40 ++++++++++++++++++++++++++++++++++++++++ tests/docker/travis.sh | 10 ++++++++++ 2 files changed, 50 insertions(+) create mode 100755 tests/docker/travis.py create mode 100755 tests/docker/travis.sh